<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Update #8                                               |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2012 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 824.97.120908-140829                                              |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Files
 * @copyright (C) 2002-2012 Esselbach Internet Solutions
 */

/**
 * function FilesDoSubmitFile
 * A function to add a file to the submission queue
 * @author Philipp Louis Esselbach
 */
function FilesDoSubmitFile()
{
	global $config, $database, $templates, $system, $preferences, $security, $user, $ipaddr;
	$input_anon_name = ( isset( $_POST[ 'input_anon_name' ] ) ) ? $security -> checkvar( $_POST[ 'input_anon_name' ] ) : "" ;
	$input_anon_email = ( isset( $_POST[ 'input_anon_email' ] ) ) ? $security -> checkvar( $_POST[ 'input_anon_email' ] ) : "" ;
	$input_securitycode = ( isset( $_POST[ 'input_securitycode' ] ) ) ? $security -> checkvar( $_POST[ 'input_securitycode' ] ) : "" ;
	$input_name = ( isset( $_POST[ 'input_name' ] ) ) ? $security -> checkvar( $_POST[ 'input_name' ] ) : "" ;
	$input_version = ( isset( $_POST[ 'input_version' ] ) ) ? $security -> checkvar( $_POST[ 'input_version' ] ) : "" ;
	$input_category = ( isset( $_POST[ 'input_category' ] ) ) ? $security -> checkvar( $_POST[ 'input_category' ] ) : "" ;
	$input_os = ( isset( $_POST[ 'input_os' ] ) ) ? $security -> checkvararray( $_POST[ 'input_os' ] ) : "" ;
	$input_smalldescription = ( isset( $_POST[ 'input_smalldescription' ] ) ) ? $security -> checkvar( $_POST[ 'input_smalldescription' ] ) : "" ;
	$input_longdescription = ( isset( $_POST[ 'input_longdescription' ] ) ) ? $security -> checkvar( $_POST[ 'input_longdescription' ] ) : "" ;
	$input_changetext = ( isset( $_POST[ 'input_changetext' ] ) ) ? $security -> checkvar( $_POST[ 'input_changetext' ] ) : "" ;
	$input_agreement = ( isset( $_POST[ 'input_agreement' ] ) ) ? $security -> checkvar( $_POST[ 'input_agreement' ] ) : "" ;
	$input_size = ( isset( $_POST[ 'input_size' ] ) ) ? $security -> checkvar( $_POST[ 'input_size' ] ) : "" ;
	$input_cost = ( isset( $_POST[ 'input_cost' ] ) ) ? $security -> checkvar( $_POST[ 'input_cost' ] ) : "" ;
	$input_company = ( isset( $_POST[ 'input_company' ] ) ) ? $security -> checkvar( $_POST[ 'input_company' ] ) : "" ;
	$input_homepage = ( isset( $_POST[ 'input_homepage' ] ) ) ? $security -> checkvar( $_POST[ 'input_homepage' ] ) : "" ;
	$input_email = ( isset( $_POST[ 'input_email' ] ) ) ? $security -> checkvar( $_POST[ 'input_email' ] ) : "" ;
	$input_language = ( isset( $_POST[ 'input_language' ] ) ) ? $security -> checkvar( $_POST[ 'input_language' ] ) : "" ;
	$input_pad = ( isset( $_POST[ 'input_pad' ] ) ) ? $security -> checkvar( $_POST[ 'input_pad' ] ) : "" ;
	$input_downloadurl1 = ( isset( $_POST[ 'input_downloadurl1' ] ) ) ? $security -> checkvar( $_POST[ 'input_downloadurl1' ] ) : "" ;
	$input_downloadurl2 = ( isset( $_POST[ 'input_downloadurl2' ] ) ) ? $security -> checkvar( $_POST[ 'input_downloadurl2' ] ) : "" ;
	$input_fields = ( isset( $_POST[ 'input_fields' ] ) ) ? $security -> checkvararray( $_POST[ 'input_fields' ] ) : "" ;
	$recaptcha_challenge_field = ( isset( $_POST[ 'recaptcha_challenge_field' ] ) ) ? $security -> checkvar( $_POST[ 'recaptcha_challenge_field' ] ) : "" ;
	$recaptcha_response_field = ( isset( $_POST[ 'recaptcha_response_field' ] ) ) ? $security -> checkvar( $_POST[ 'recaptcha_response_field' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_menu_header','site_menu_item_header','site_menu_sub_item_header','site_menu_sub_item_footer','site_menu_item_footer','site_menu_item_admin','site_menu_footer','site_block','site_block_alt1','site_block_alt2','site_login_anon','site_login_user','site_login_cookie','site_invalid_form','files_submission_header','files_submission_done','files_submission_footer','files_submission_error_noname','files_submission_error_noemail','files_submission_error_padexists','files_submission_error_banned','files_submission_error_noprogramname','files_submission_error_nodescription','files_submission_error_nourl','files_submission_error_userexists','files_submission_error_emailexists','files_error_securitycode','files_submission_email_subject','files_submission_email_body'", $preferences[ 'current_theme' ] );
	$insert = $system -> getinsert( $preferences, $main_templates );
	$insert[ 'page_name' ] = $preferences[ 'website_name' ];
	$insert[ 'page_description' ] = $preferences[ 'website_description' ];
	$insert[ 'page_keywords' ] = $preferences[ 'website_keywords' ];

	if( !$user[ 'user_nocookie' ] )
	{
    	session_start();

    	if( ( $_SESSION[ 'files_security_hash' ] != $input_security_hash ) and( $preferences[ 'website_subsessions_user' ] ) )
    	{
    		echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
    		echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
    		echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
    		exit;
    	}
	}

	if( $preferences[ 'files_allow_submissions' ] )
	{
		if( $preferences[ 'files_allow_unregsubmit' ] and !$user[ 'user_status' ] )
		{
			$input_authorid = 0;
			$input_author = $input_anon_name;
			$input_email = $input_anon_email;

			if( !$input_anon_name )
			{
				$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_noname_html' ], $main_templates[ 'files_submission_error_noname_php' ], $insert );
			}
			elseif( !$input_anon_email )
			{
				$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_noemail_html' ], $main_templates[ 'files_submission_error_noemail_php' ], $insert );
			}
		}

		if( $user[ 'user_status' ] )
		{
			$input_authorid = $database -> dbescape( $user[ 'user_id' ] );
			$input_author = $database -> dbescape( $user[ 'user_name' ] );
			$input_email = $database -> dbescape( $user[ 'user_email' ] );
		}

		if( $preferences[ 'files_securitycode' ] )
		{
			if( ( $preferences[ 'website_recaptcha' ] ) and ( $preferences[ 'website_recaptcha_public_key' ] ) and ( $preferences[ 'website_recaptcha_private_key' ] ) and function_exists( "curl_exec" ) )
			{
				$recaptcha_error = $system -> dorecaptcha( $preferences[ 'website_recaptcha_private_key' ], $ipaddr, $recaptcha_challenge_field, $recaptcha_response_field );
				if ( $recaptcha_error )
				{
					$error = $templates -> exectemplate( $main_templates[ 'files_error_securitycode_html' ], $main_templates[ 'files_error_securitycode_php' ], $insert );
				}
			}
			elseif( function_exists( "imagestring" ) )
			{
				if( $_SESSION[ 'files_security_code' ] != $input_securitycode )
				{
					$error = $templates -> exectemplate( $main_templates[ 'files_error_securitycode_html' ], $main_templates[ 'files_error_securitycode_php' ], $insert );
				}
			}
		}

		if( $preferences[ 'files_allow_unregsubmit' ] or $user[ 'user_status' ] )
		{
			if( $user[ 'user_status' ] == 5 )
			{
				$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_banned_html' ], $main_templates[ 'files_submission_error_banned_php' ], $insert );
			}
			elseif( !$input_name )
			{
				$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_noprogramname_html' ], $main_templates[ 'files_submission_error_noprogramname_php' ], $insert );
			}
			elseif( !$input_smalldescription )
			{
				$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_nodescription_html' ], $main_templates[ 'files_submission_error_nodescription_php' ], $insert );
			}
			elseif( !$input_downloadurl1 )
			{
				$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_nourl_html' ], $main_templates[ 'files_submission_error_nourl_php' ], $insert );
			}

			$query = $database -> dbquery( "SELECT file_id FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_pad = '" . $input_pad . "'" );

			if( $database -> dbrows( $query ) )
			{
				$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_padexists_html' ], $main_templates[ 'files_submission_error_padexists_php' ], $insert );
			}

			if( !isset( $error ) and !$user[ 'user_status' ] )
			{
				$query = $database -> dbquery( "SELECT user_id FROM " . DB_PREFIX . "esselbach_ct_users WHERE user_name = '" . $input_anon_name . "'" );

				if( $database -> dbrows( $query ) )
				{
					$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_userexists_html' ], $main_templates[ 'files_submission_error_userexists_php' ], $insert );
				}

				$query = $database -> dbquery( "SELECT user_id FROM " . DB_PREFIX . "esselbach_ct_users WHERE user_email = '" . $input_anon_email . "'" );

				if( $database -> dbrows( $query ) )
				{
					$error = $templates -> exectemplate( $main_templates[ 'files_submission_error_emailexists_html' ], $main_templates[ 'files_submission_error_emailexists_php' ], $insert );
				}
			}
		}

		if( isset( $error ) )
		{
			FilesSubmitFile( $error );
		}
		else
		{
			$templates -> initgzip();
			echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );

			if( $preferences[ 'files_navigation' ] )
			{
				echo $templates -> exectemplate( $main_templates[ 'files_submission_header_html' ], $main_templates[ 'files_submission_header_php' ], $insert );
			}

			if( is_array( $input_fields ) )
			{
				$input_fields_encoded = base64_encode( $input_fields[ 0 ] );

				for( $i = 1; $i < 24; $i++ )
				{
					$input_fields_encoded .= "|";

					if( isset( $input_fields[ $i ] ) )
					{
						$input_fields_encoded .= base64_encode( $input_fields[ $i ] );
					}
				}
			}
			else
			{
				$input_fields_encoded = "";
			}

			$input_smalldescription_parsed = stripslashes( $input_smalldescription );
			$input_longdescription_parsed = stripslashes( $input_longdescription );
			$input_smalldescription_parsed = $system -> dechomp( $input_smalldescription_parsed );
			$input_longdescription_parsed = $system -> dechomp( $input_longdescription_parsed );
			$input_smalldescription_parsed = $system -> smilies( $input_smalldescription_parsed );
			$input_longdescription_parsed = $system -> smilies( $input_longdescription_parsed );
			$input_smalldescription_parsed = $system -> code( $input_smalldescription_parsed );
			$input_longdescription_parsed = $system -> code( $input_longdescription_parsed );
			$input_smalldescription_parsed = $database -> dbescape( $input_smalldescription_parsed );
			$input_longdescription_parsed = $database -> dbescape( $input_longdescription_parsed );
			$input_seo = $system -> doseo( $input_name );
			$query = $database -> dbquery( "SELECT COUNT(file_id) FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_seo = '" . $input_seo . "'" );
			list( $seo_files ) = $database -> dbrow( $query );

			if( $seo_files )
			{
				$input_seo .= "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
			}

			if( is_array( $input_os ) )
			{
				$input_file_os_list = implode( ",", $input_os );
			}
			else
			{
				$input_file_os_list = "";
			}

			$ignore_submission = 0;

			if( $preferences[ 'files_submissions_ignore' ] )
			{
				$ignored_words = explode( " ", $preferences[ 'fils_submissions_ignore' ] );

				for( $i = 0; $i < count( $ignored_words ); $i++ )
				{

					if( ( preg_match( "/" . $ignored_words[ $i ] . "/i", $input_name ) ) or( preg_match( "/" . $ignored_words[ $i ] . "/i", $input_smalldescription ) ) or( preg_match( "/" . $ignored_words[ $i ] . "/i", $input_longdescription ) ) )
					{
						$ignore_submission = 1;
					}
				}
			}

			if( !$ignore_submission )
			{
				if( $preferences[ 'files_submissions_email' ] )
				{
					$query = $database -> dbquery( "SELECT u.user_name, u.user_email FROM " . DB_PREFIX . "esselbach_ct_users u, " . DB_PREFIX . "esselbach_ct_permissions p WHERE p.permission_admin = u.user_loginname AND p.permission_module = 'files' AND p.permission_setting = '1' AND u.user_status = '2'" );

					while( list( $user_name, $user_email ) = $database -> dbrow( $query ) )
					{
						$insert[ 'filequeue_name' ] = stripslashes( $input_name );
						$insert[ 'filequeue_version' ] = stripslashes( $input_version );
						$insert[ 'filequeue_author' ] = stripslashes( $input_author );
						$insert[ 'filequeue_smalldescription' ] = stripslashes( $input_smalldescription );
						$email_subject = $templates -> exectemplate( $main_templates[ 'files_submission_email_subject_html' ], $main_templates[ 'files_submission_email_subject_php' ], $insert );
						$email_body = $templates -> exectemplate( $main_templates[ 'files_submission_email_body_html' ], $main_templates[ 'files_submission_email_welcomebody_php' ], $insert );
						$email_header = $system -> mailheader( $preferences[ 'user_registration_adminname' ], $preferences[ 'user_registration_adminemail' ], $user_name, $user_email );

						if( $preferences[ 'user_registration_emailserver' ] == "SMTP" )
						{
							$error = $system -> smtpmail( $preferences[ 'user_registration_smtphost' ], $preferences[ 'user_registration_smtpport' ], $preferences[ 'user_registration_smtpusername' ], $preferences[ 'user_registration_smtppassword' ], $preferences[ 'user_registration_adminemail' ], $user_email, $email_subject, $email_body, $email_header );
						}
						else
						{
							mail( $user_email, $email_subject, $email_body, $email_header );
						}
					}
				}

				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesqueue (filequeue_id, filequeue_authorid, filequeue_author, filequeue_email, filequeue_status, filequeue_website, filequeue_category, filequeue_name, filequeue_version, filequeue_pad, filequeue_smalldescription, filequeue_longdescription, filequeue_size, filequeue_cost, filequeue_company, filequeue_homepage, filequeue_companyemail, filequeue_language, filequeue_os, filequeue_changeinfo, filequeue_agreement, filequeue_downloadurl1, filequeue_downloadurl2, filequeue_fields, filequeue_postip, filequeue_editip, filequeue_editadmin) VALUES (NULL, '" . $input_authorid . "', '" . $input_author . "', '" . $input_email . "', '0', '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $input_category . "', '" . $input_name . "', '" . $input_version . "', '" . $input_pad . "', '" . $input_smalldescription . "', '" . $input_longdescription . "', '" . $input_size . "', '" . $input_cost . "', '" . $input_company . "', '" . $input_homepage . "', '" . $input_email . "', '" . $input_language . "', '" . $input_file_os_list . "', '" . $input_changetext . "', '" . $input_agreement . "', '" . $input_downloadurl1 . "', '" . $input_downloadurl2 . "', '" . $input_fields_encoded . "', '" . $ipaddr . "', '" . $ipaddr . "', '')" );
			}

			echo $templates -> exectemplate( $main_templates[ 'files_submission_done_html' ], $main_templates[ 'files_submission_done_php' ], $insert );

			if( $preferences[ 'files_navigation' ] )
			{
				echo $templates -> exectemplate( $main_templates[ 'files_submission_footer_html' ], $main_templates[ 'files_submission_footer_php' ], $insert );
			}

			echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
		}
	}
}
?>